* ITSP 14.2

sysuse auto,clear
qui desc
g model = ""
forv i=1/`=r(N)' {
	local temp = make[`i']
	local model: word 2 of `temp'
	qui replace model = "`model'" in `i'
}
keep in 1/15
keep make model price
l make model
save ch14.2,replace

/*
program drop _all
program shufstr
version 10.1
syntax varlist(string max=1)
mata: shufstr("`varlist'")
end
version 10.1
mata: mata clear
mata:
void function shufstr(string vector vname)
{
	st_sview(S=. , ., vname)
	for(i = 1 ; i <= rows(S);  i++) {
	S[i , .] =char(jumble(ascii(S[i , .])')')
 }
}

end
*/
type shufstr.ado

do shufstr.mata

type shufstr.mata

clear
sysuse auto, clear
generate model = ""
quietly describe
forvalues i = 1/`=r(N)' {
	local temp = make[`i']
	local model: word 2 of `temp'
	qui replace model = "`model'" in `i'
}
keep in 1/15
keep make model price
generate shufmod = model
set seed 20080906
shufstr(shufmod)
list, sep(0) noobs
